$.fn.fmatter.comment = function (cval, opts) {
  var op = $.extend({}, opts.checkbox),
    ds;
  if (opts.colModel !== undefined && opts.colModel.formatoptions !== undefined) {
    op = $.extend({}, op, opts.colModel.formatoptions);
  }
  if ($.fmatter.isEmpty(cval) || cval === undefined) {
    cval = $.fn.fmatter.defaultFormat(cval, op);
  }

  cval = cval + '';
  cval = cval.toLowerCase();
  var checked = /false|f|0|no|n|off|undefined/i.test(cval) ? '' : " checked='checked' ";
  var disabled = op.disabled ? ' disabled="disabled"' : '';
  var el =
    '<input type="checkbox"' + checked + disabled + ' value="' + cval + '"' + ' offval="no"' + ' onchange="$.fn.fmatter.commentFN(this)"/>';
  return el;
};
$.fn.fmatter.commentFN = function (e) {
  var t = $(e);
  //var rowid = t.closest('tr').attr('id');
  var table = t.closest('table');
  var rowid = t.closest('tr').attr('id');
  var cellname = t
    .parent()
    .attr('aria-describedby')
    .replace(table.attr('id') + '_', '');
  table.jqGrid('setCell', rowid, cellname, e.checked ? 1 : 0);
};

$.fn.fmatter.condition = function (cval, opts, Item) {
  if ($.fmatter.isEmpty(cval) || cval === undefined) {
    cval = $.fn.fmatter.defaultFormat(cval, opts);
  }
  //debugger
  cval = cval + '';
  cval = cval.toLowerCase();

  var checked = /false|f|0|no|n|off|undefined/i.test(cval) ? '' : " checked='checked' ",
    disabled = opts.disabled ? ' disabled="disabled"' : '',
    el;
  var It = Item;
  if (typeof Item._type == 'undefined') {
    It = $(this).jqGrid('getRowData', opts.rowId);
  }
  if (It._type == 'TS' || It._type == 'DTS' || It._type == 'STRT') {
    el =
      '<b>' +
      (opts.colModel.name == 'level_lower' ? 0 : 1) +
      '</b>&nbsp;<input type="checkbox"' +
      checked +
      disabled +
      ' value="' +
      cval +
      '"' +
      ' offval="no"' +
      ' onchange="$.fn.fmatter.conditionFN(this)"/>';
  } else {
    el =
      '<input type="text"' +
      disabled +
      ' value="' +
      cval +
      '"' +
      ' offval="no"' +
      ' onchange="$.fn.fmatter.conditionFN(this)" onkeyup="$.fn.fmatter.conditionKP(event, this)"/>';
  }
  return el;
};
$.fn.fmatter.condgist = function (cval, opts, Item) {
  if ($.fmatter.isEmpty(cval) || cval === undefined) {
    cval = $.fn.fmatter.defaultFormat(cval, opts);
  }
  //debugger
  cval = cval + '';
  cval = cval.toLowerCase();

  var It = Item;
  if (typeof Item._type == 'undefined') {
    It = $(this).jqGrid('getRowData', opts.rowId);
  }

  var disabled = It._type == 'TS' || It._type == 'DTS' || It._type == 'STRT' ? ' disabled="disabled"' : '',
    el;

  el =
    '<input type="text"' +
    disabled +
    ' value="' +
    cval +
    '"' +
    ' offval="no"' +
    ' onchange="$.fn.fmatter.conditionFN(this)" onkeyup="$.fn.fmatter.conditionKP(event, this)"/>';
  return el;
};
$.fn.fmatter.conditionKP = function (e, inp) {
  if (inp.value.trim() == '') {
    var t = $(inp);
    var table = t.closest('table'),
      row = table.jqGrid('getRowData', t.closest('tr').attr('id'));
    if (
      $(inp).parents('tr:first').find('[aria-describedby*="level_lower"] input').val().trim() == '' &&
      $(inp).parents('tr:first').find('[aria-describedby*="level_upper"] input').val().trim() == ''
    ) {
      $(inp).parents('tr:first').find('[aria-describedby*="Enabled"] input').get(0).disabled = true;
      $(inp).parents('tr:first').find('[aria-describedby*="Enabled"] input').get(0).checked = false;
    }
  } else $(inp).parents('tr:first').find('[aria-describedby*="Enabled"] input').get(0).disabled = false;
};
$.fn.fmatter.conditionFN = function (e) {
  var t = $(e);
  //var rowid = t.closest('tr').attr('id');
  var table = t.closest('table'),
    row = table.jqGrid('getRowData', t.closest('tr').attr('id')),
    rowid = t.closest('tr').attr('id');
  var cellname = t
    .parent()
    .attr('aria-describedby')
    .replace(table.attr('id') + '_', '');

  if (row._type == 'TS' || row._type == 'DTS' || row._type == 'STRT') table.jqGrid('setCell', rowid, cellname, e.checked ? 1 : 0);
  else {
    if (e.value == '') e.value += ' ';
    table.jqGrid('setCell', rowid, cellname, e.value);
  }
};
$.fn.fmatter.password = function (e) {
  return '*********';
};
$.fn.fmatter.condiec = function (cval, opts, Item) {
  if ($.fmatter.isEmpty(cval) || cval === undefined) {
    cval = $.fn.fmatter.defaultFormat(cval, opts);
  }
  //debugger
  cval = cval + '';
  cval = cval.toLowerCase();

  var disabled = cval == '-' ? ' disabled="disabled"' : '',
    el;

  el =
    '<input type="text"' +
    disabled +
    ' value="' +
    cval +
    '"' +
    ' offval="no"' +
    ' onchange="$.fn.fmatter.condiecFN(this)" style="text-align: right;width: 100%;border: 1px solid #868686;box-shadow: inset 0 0 1px 0px black;padding: 1px 3px 0px;"/>';
  return el;
};
$.fn.fmatter.condiecFN = function (e) {
  var t = $(e);
  var table = t.closest('table'),
    rowid = t.closest('tr').attr('id');
  var cellname = t
    .parent()
    .attr('aria-describedby')
    .replace(table.attr('id') + '_', '');

  if (e.value == '') e.value += ' ';
  table.jqGrid('setCell', rowid, cellname, e.value);
};

$.fn.fmatter.commentPwd = function (cval, opts) {
  var op = $.extend({}, opts.checkbox),
    ds;
  if (opts.colModel !== undefined && opts.colModel.formatoptions !== undefined) {
    op = $.extend({}, op, opts.colModel.formatoptions);
  }
  if ($.fmatter.isEmpty(cval) || cval === undefined) {
    cval = $.fn.fmatter.defaultFormat(cval, op);
  }

  cval = cval + '';
  cval = cval.toLowerCase();
  var checked = /^[false|0|no|n|off|undefined]/i.test(cval) ? '' : " checked='checked' ";
  //var disabled = op.disabled ? ' disabled="disabled"' : '';
  var el = '<input type="checkbox"' + checked + ' value="' + cval + '"' + ' offval="no"' + ' onchange="$.fn.fmatter.commentFNPwd(this)"/>';
  return el;
};
$.fn.fmatter.commentFNPwd = function (e) {
  var t = $(e);
  //var rowid = t.closest('tr').attr('id');
  var table = t.closest('table');
  var rowid = t.closest('tr').attr('id');
  var cellname = t
    .parent()
    .attr('aria-describedby')
    .replace(table.attr('id') + '_', '');
  table.jqGrid('setCell', rowid, cellname, e.checked ? 'http,ftp,61850' : '0');
};
